uniform float ContourIntervall;
uniform float threshold;
uniform float type;
uniform float minz;
uniform float maxz;
uniform float offset; 
uniform float red_1;
uniform float green_1;
uniform float blue_1;
uniform float red_2;
uniform float green_2;
uniform float blue_2;
uniform float red_3;
uniform float green_3;
uniform float blue_3;
uniform float transparency;

void directionalLight0(
    in    vec3 normal,
    inout vec4 ambient,
    inout vec4 diffuse,
    inout vec4 specular,
    in float zdir)
{
 
    // Normalized light direction and half vector
     vec3 thePosition=vec3(gl_LightSource[0].position);
    thePosition.x*=zdir;
    thePosition.y*=zdir;
     thePosition.z*=zdir;
    vec3 lightDirection = normalize(vec3(thePosition));
    
    vec3 halfVector =  vec3(gl_LightSource[0].halfVector);
    halfVector.x*=zdir;
    halfVector.y*=zdir;
    halfVector.z*=zdir;
    halfVector = normalize(halfVector);
    
    float nDotVP; // normal . light_direction
    float nDotHV; // normal . light_half_vector
    float pf; // power factor

    nDotVP = max(0.0, dot(normal, lightDirection));
    nDotHV = max(0.0, dot(normal, halfVector));

    if (nDotVP == 0.0) {
   pf = 0.0;
    }
    else {
   pf = pow(nDotHV, gl_FrontMaterial.shininess);
    }

    ambient += gl_LightSource[0].ambient;
    diffuse += gl_LightSource[0].diffuse * nDotVP;
    specular += gl_LightSource[0].specular * pf;
}


// Per-pixel normal (input from vertex shader)
varying vec3  Normal;
varying vec3 Position;
varying vec3 realNormal;
 
void main()
{

 
    vec3 unitNorm = normalize(Normal);
    vec4 amb = vec4(0.0);
    vec4 diff = vec4(0.0);
    vec4 spec = vec4(0.0);
    int i;

    directionalLight0(unitNorm,  amb, diff, spec,1.);
    directionalLight0(unitNorm,  amb, diff, spec,-1.);

    // Apply the result of the lighting equation
   
    float colorFactor=0.5;
    float deltaRed= (red_2-red_1);
    float deltaGreen= (green_2-green_1);
    float deltaBlue= (blue_2-blue_1);
    
    float deltaRed1= (red_3-red_2);
    float deltaGreen1= (green_3-green_2);
    float deltaBlue1= (blue_3-blue_2);
    vec4 newColor=vec4(0.0);
    
    float thisMinZ = minz;
    float thisMaxZ = maxz;
   
    
    if (type==2.) {
     
       thisMinZ=(1.-maxz);
       thisMaxZ=(1.-minz);
       
    }
    
   
    
     float deltaZ=thisMaxZ-thisMinZ;
     
     
  if (deltaZ > 0.0000001){
   
     if (type == 2.) {
      
        
        colorFactor=(1.-abs(realNormal.z -thisMinZ))/deltaZ;
        
        
        }
     
     
     
     if (type == 3.) {
     
      
           float PI=3.14159;
    
           deltaZ=2.*PI;
         
           vec2 newNormal;
         
           newNormal=vec2(realNormal.x,realNormal.y); 
         
         
        // die OpenGL hat hier offensichtlich einen Fehler beim Normalisieren
        // daher das ganze hier selbstgestrickt  -   16.09.2010 HGS
         
           float length=sqrt(newNormal.x*newNormal.x+newNormal.y*newNormal.y);
        
           if (length > 0.00001) {
           newNormal.x/=length;
           newNormal.y/=length;
         
           float theCosinus=newNormal.y;
        
           float angle=acos(theCosinus);
       
           if (realNormal.x < 0.) angle=2.*PI-angle;
   
           colorFactor=angle/deltaZ;
        
        } 
      
        
     }  
    
     
     
     if (type ==0.) colorFactor=(Position.z+offset-thisMinZ)/deltaZ;
     if (type ==1.) colorFactor=(Position.z+offset-thisMinZ)/deltaZ;
    }
  
    if (colorFactor < 0.5) {
       colorFactor*=2.;
       newColor=vec4(red_1+colorFactor*deltaRed,green_1+colorFactor*deltaGreen,blue_1+deltaBlue*colorFactor,transparency);
     } else {
 
       colorFactor=(colorFactor-0.5)*2.;
       newColor=vec4(red_2+colorFactor*deltaRed1,green_2+colorFactor*deltaGreen1,blue_2+deltaBlue1*colorFactor,transparency);
 
   
     }
   // vec4 secondaryColor = vec4(vec3(spec * gl_FrontMaterial.specular), transparency);
  
    vec4 color = vec4(vec3(  amb * newColor + diff * newColor), transparency);
    
    
 
    
    if (type ==1.) 
    if (ContourIntervall != 0.){
    
    
         float iv=maxz-minz;
    
         float numIntervalls=iv / ContourIntervall;
         float factor= 1. / numIntervalls;
         int startIntervall=int(minz/ContourIntervall);
         int ivNumber=int(((Position.z+offset)/ContourIntervall) - float(startIntervall));
         color*=(0.5+(factor*float(ivNumber)));
          
         if (threshold == 1.)
              if (fract(float(ivNumber) /2. ) == 0.) discard;
 
      } 
       color.w=transparency;
     gl_FragColor = color ;
    

   
}