//  const float EtaR = 0.655;  // Ratio of indices of refraction
//  const float EtaG = 0.66;
// const float EtaB = 0.665;

const float EtaR = 1.;  // Ratio of indices of refraction
const float EtaG = 1.;
const float EtaB = 1.;


const float FresnelPower = 1.0;

const float F= ((1.0-EtaG) * (1.0-EtaG)) / ((1.0+EtaG) * (1.0+EtaG));
 
 varying vec3  Reflect;
 varying vec3 RefractR; 
 varying vec3 RefractG;
 varying vec3 RefractB;
  varying float Ratio;
 
void main(void)
{

   vec4 ecPosition = gl_ModelViewMatrix * gl_Vertex;
   vec3 ecPosition3 = ecPosition.xyz / ecPosition.w;
   
   vec3 i = normalize(ecPosition3);
   vec3 n= normalize(gl_NormalMatrix * gl_Normal);
   
   Ratio = F + (1.0 -F) * pow ((1.0 - dot(-i,n)), FresnelPower);
   
   RefractR = refract(i,n,EtaR);
   RefractR = vec3(gl_TextureMatrix[0] * vec4(RefractR,1.0));
   
   RefractG = refract(i,n,EtaG);
   RefractG = vec3(gl_TextureMatrix[0] * vec4(RefractG,1.0));
   
   RefractB = refract(i,n,EtaB);
   RefractB = vec3(gl_TextureMatrix[0] * vec4(RefractB,1.0));
   
   Reflect =reflect(i,n);
   Reflect = vec3(gl_TextureMatrix[0] * vec4(Reflect,1.0));   
   
   Reflect -=0.5;
   
   
   RefractR-=0.5;
   RefractG-=0.5;
   RefractB-=0.5;
    
     gl_TexCoord[0] = gl_MultiTexCoord0;
	 gl_Position = ftransform();  
	 
}
