
 uniform sampler3D TextureGrid;
 

void directionalLight0(
    in    vec3 normal,
    inout vec4 ambient,
    inout vec4 diffuse,
    inout vec4 specular,
   
    in float zdir)
{
    
    // Normalized light direction and half vector
    vec3 thePosition=vec3(gl_LightSource[0].position);
    thePosition.z*=zdir;
    vec3 lightDirection = normalize(vec3(thePosition));
    
   // vec3 lightDirection={1.,0.,0.};
   // lightDirection.x*=zdir;
    
    vec3 halfVector =  vec3(gl_LightSource[0].halfVector);
    halfVector.x*=zdir;
    halfVector = normalize(halfVector);
    
    float nDotVP; // normal . light_direction
    float nDotHV; // normal . light_half_vector
    float pf; // power factor

    nDotVP = max(0.0, dot(normal, lightDirection));
    nDotHV = max(0.0, dot(normal, halfVector));

    if (nDotVP == 0.0) {
	pf = 0.0;
    }
    else {
	pf = pow(nDotHV, gl_FrontMaterial.shininess);
    }

    ambient += gl_LightSource[0].ambient;
    diffuse += gl_LightSource[0].diffuse * nDotVP;
    specular += gl_LightSource[0].specular * pf;

}

 

// Per-pixel normal (input from vertex shader)
varying vec3  Normal;
varying vec3 Position;
varying vec3 texcoor;
varying vec3  EyeDir;

void main()
{
    vec3 unitNorm = normalize(Normal);
    vec4 amb = vec4(0.0);
    vec4 diff = vec4(0.0);
    vec4 spec = vec4(0.0);
   
   
    vec4 envColor=vec4(texture3D(TextureGrid,texcoor));
    
    if (envColor.x == 0.) discard;
    
     envColor.y = envColor.x;
     envColor.z = envColor.x;
   
   
     
   
     directionalLight0(unitNorm,  amb, diff, spec,1.);
     directionalLight0(unitNorm,  amb, diff, spec,-1.);
    
     vec4 color2 = vec4(vec3(diff * envColor +
		       amb * envColor +
		       diff * envColor),1.0);
		   
     // Holen des Alpha-Wertes fuer die Transparenz
     color2.w=gl_FrontMaterial.diffuse.w;
  
    
    gl_FragColor = color2 ;
    
 
}
