 
 
varying vec3  Normal;
varying vec3 Position; 
 
 
uniform sampler2D theTex;
uniform float xminImage;
uniform float yminImage;
uniform float deltax;
uniform float deltay;

void directionalLight0(
    in    vec3 normal,
    inout vec4 ambient,
    inout vec4 diffuse,
    inout vec4 specular,
    in float zdir)
{
 
    // Normalized light direction and half vector
     vec3 thePosition=vec3(gl_LightSource[0].position);
    thePosition.x*=zdir;
    thePosition.y*=zdir;
     thePosition.z*=zdir;
    vec3 lightDirection = normalize(vec3(thePosition));
    
    vec3 halfVector =  vec3(gl_LightSource[0].halfVector);
    halfVector.x*=zdir;
    halfVector.y*=zdir;
    halfVector.z*=zdir;
    halfVector = normalize(halfVector);
    
    float nDotVP; // normal . light_direction
    float nDotHV; // normal . light_half_vector
    float pf; // power factor

    nDotVP = max(0.0, dot(normal, lightDirection));
    nDotHV = max(0.0, dot(normal, halfVector));

    if (nDotVP == 0.0) {
	pf = 0.0;
    }
    else {
	pf = pow(nDotHV, gl_FrontMaterial.shininess);
    }

    ambient += gl_LightSource[0].ambient;
    diffuse += gl_LightSource[0].diffuse * nDotVP;
    specular += gl_LightSource[0].specular * pf;
}




void main (void)
{

    
   
    //vec3 unitNorm = normalize(Normal);
 

    vec4 amb =  vec4(0.0);
    vec4 diff =  vec4(0.0);
    vec4 spec =  vec4(0.0);
    
 
    
     directionalLight0(Normal,  amb, diff, spec,1.);
     directionalLight0(Normal,  amb, diff, spec,-1.);
    
    // vec2 tc=gl_TexCoord[0].st;
   vec2 tc=vec2( (Position.x-xminImage)*deltax,(Position.y-yminImage)*deltay); 
    //tc.s=(Position.x-xminImage)*deltax;
    //tc.t=(Position.y-yminImage)*deltay;
    
    
    
   // if (Position.x < xminImage) discard;
    // if (Position.y < yminImage) discard;
    
   // if ( ((Position.x-xminImage)*deltax) > 1.) discard;
   // if (  ((Position.y-yminImage)*deltay) > 1.) discard;
    
     if (tc.s < 0.) discard;
      if (tc.t < 0.) discard;
    
     if (tc.s > 1.) discard;
     if (tc.t > 1.) discard;
     
    
    vec4 envColor=vec4(texture2D(theTex,tc));
     
    if (envColor.w == 0.) discard;
    
   
  

     vec4 color2 = vec4(vec3(amb * envColor +diff * envColor ),1.0) ;
     
     
     // Holen des Alpha-Wertes fuer die Transparenz
     color2.w=gl_FrontMaterial.diffuse.w;
   
    
      gl_FragColor =color2;
      
     
}
